"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpLoggerMiddleware = void 0;
const common_1 = require("@nestjs/common");
const chalk = require("chalk");
const isEmpty = (obj) => JSON.stringify(obj) === '{}';
let HttpLoggerMiddleware = class HttpLoggerMiddleware {
    constructor() {
        this.logger = new common_1.Logger('HTTP');
        this.log = (...args) => this.logger.log(chalk.magenta(...args));
    }
    use(req, _res, next) {
        const { body, params, query } = req;
        const requestUrl = `${req.protocol}://${req.get('host')}${req.originalUrl}`;
        this.log('---------------------------------------------------------------------------------');
        this.log('request method:', req.method);
        this.log('request url: ', requestUrl);
        if (query && !isEmpty(query)) {
            this.log('request query: ', JSON.stringify(query));
        }
        if (params && !isEmpty(params)) {
            this.log('request params: ', JSON.stringify(params));
        }
        if (body && !isEmpty(body)) {
            this.log('request body: ', JSON.stringify(body));
        }
        this.log('---------------------------------------------------------------------------------');
        next();
    }
};
HttpLoggerMiddleware = __decorate([
    (0, common_1.Injectable)()
], HttpLoggerMiddleware);
exports.HttpLoggerMiddleware = HttpLoggerMiddleware;
//# sourceMappingURL=http-logger-middleware.js.map